#include <stdio.h>
#include <include/types.h>
#include <include/pflash.h>
#include <include/tgt/bonito.h>
#include <include/tgt/pflash_tgt.h>
/*
 *  Flash programming support code.
 */

/*
 *  Table of flash devices on target. See pflash_tgt.h.
 */

struct fl_map tgt_fl_map_boot8[] = {
	TARGET_FLASH_DEVICES_8
};


extern unsigned int membase;
struct fl_map *tgt_flashmap ()
{
	struct fl_map *map = tgt_fl_map_boot8;
	if (!map->inited)
	{
		map->fl_map_base += membase - 0x10000000;
		map->inited = 1;
	}
	return tgt_fl_map_boot8;
}

void tgt_flashwrite_disable ()
{
}

int tgt_flashwrite_enable ()
{
	return (1);
}

void tgt_flashinfo (void *p, size_t * t)
{
	struct fl_map *map;

	map = fl_find_map (p);
	if (map)
	{
		*t = map->fl_map_size;
	}
	else
	{
		*t = 0;
	}
}

void tgt_flashprogram (void *p, int size, void *s, int endian)
{
	printf ("Programming flash %x:%x into %x\n", s, size, p);
	if (fl_erase_device (p, size, TRUE))
	{
		printf ("Erase failed!\n");
		return;
	}
	if (fl_program_device (p, s, size, TRUE))
	{
		printf ("Programming failed!\n");
	}
	fl_verify_device (p, s, size, TRUE);
}

#include "dev/flash.c"
